Read DaVinci Flow Node Metrics
POST {{apiPath}}/v1/environments/{{envID}}/metrics/davinci
The POST {{apiPath}}/v1/environments/{{envID}}/metrics/davinci request returns DaVinci flow node data for the specified environment. The entityType property in the request body must specify DAVINCI_FLOW_NODE_METRICS to return flow node data.
Request Model
| Property | Type | Required |
|---|---|---|
|
Object |
Required |
|
String |
Required |
|
Object |
Required |
|
Object |
Required |
|
Object |
Required |
|
Object |
Required |
For full property descriptions, refer to the DaVinci flow activities data model.
Body
raw ( application/json )
{
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": ["{{davinciFlowID}}"]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": ["2026-08-19T00:00:00Z"]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
}
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/metrics/davinci' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": ["{{davinciFlowID}}"]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": ["2026-08-19T00:00:00Z"]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/metrics/davinci")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@" ""entityType"": ""DAVINCI_FLOW_NODE_METRICS""," + "\n" +
@" ""selectFields"": [" + "\n" +
@" ""companyId""," + "\n" +
@" ""flowId""," + "\n" +
@" ""nodeId""," + "\n" +
@" ""bucketTimestamp""" + "\n" +
@" ]," + "\n" +
@" ""aggregations"": [" + "\n" +
@" {" + "\n" +
@" ""field"": ""invocationCount""," + "\n" +
@" ""aggregatorType"": ""SUM""," + "\n" +
@" ""alias"": ""invocationCount""" + "\n" +
@" }," + "\n" +
@" {" + "\n" +
@" ""field"": ""completionCount""," + "\n" +
@" ""aggregatorType"": ""SUM""," + "\n" +
@" ""alias"": ""completionCount""" + "\n" +
@" }," + "\n" +
@" {" + "\n" +
@" ""field"": ""errorCount""," + "\n" +
@" ""aggregatorType"": ""SUM""," + "\n" +
@" ""alias"": ""errorCount""" + "\n" +
@" }," + "\n" +
@" {" + "\n" +
@" ""field"": ""timeoutCount""," + "\n" +
@" ""aggregatorType"": ""SUM""," + "\n" +
@" ""alias"": ""timeoutCount""" + "\n" +
@" }," + "\n" +
@" {" + "\n" +
@" ""field"": ""executionTime""," + "\n" +
@" ""aggregatorType"": ""AVG""," + "\n" +
@" ""alias"": ""executionTime""" + "\n" +
@" }" + "\n" +
@" ]," + "\n" +
@" ""queryFilters"": [" + "\n" +
@" {" + "\n" +
@" ""field"": ""flowId""," + "\n" +
@" ""operator"": ""EQUALS""," + "\n" +
@" ""values"": [""{{davinciFlowID}}""]" + "\n" +
@" }," + "\n" +
@" {" + "\n" +
@" ""field"": ""bucketTimestamp""," + "\n" +
@" ""operator"": ""LESS_THAN""," + "\n" +
@" ""values"": [""2026-08-19T00:00:00Z""]" + "\n" +
@" } " + "\n" +
@" ]," + "\n" +
@" ""groupBy"": [" + "\n" +
@" ""companyId""," + "\n" +
@" ""flowId""," + "\n" +
@" ""nodeId""," + "\n" +
@" ""bucketTimestamp""" + "\n" +
@" ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{apiPath}}/v1/environments/{{envID}}/metrics/davinci"
method := "POST"
payload := strings.NewReader(`{
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": ["{{davinciFlowID}}"]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": ["2026-08-19T00:00:00Z"]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
}`)
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("Content-Type", "application/json")
req.Header.Add("Authorization", "Bearer {{accessToken}}")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/metrics/davinci HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}
{
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": ["{{davinciFlowID}}"]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": ["2026-08-19T00:00:00Z"]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
}
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n \"entityType\": \"DAVINCI_FLOW_NODE_METRICS\",\n \"selectFields\": [\n \"companyId\",\n \"flowId\",\n \"nodeId\",\n \"bucketTimestamp\"\n ],\n \"aggregations\": [\n {\n \"field\": \"invocationCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"invocationCount\"\n },\n {\n \"field\": \"completionCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"completionCount\"\n },\n {\n \"field\": \"errorCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"errorCount\"\n },\n {\n \"field\": \"timeoutCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"timeoutCount\"\n },\n {\n \"field\": \"executionTime\",\n \"aggregatorType\": \"AVG\",\n \"alias\": \"executionTime\"\n }\n ],\n \"queryFilters\": [\n {\n \"field\": \"flowId\",\n \"operator\": \"EQUALS\",\n \"values\": [\"{{davinciFlowID}}\"]\n },\n {\n \"field\": \"bucketTimestamp\",\n \"operator\": \"LESS_THAN\",\n \"values\": [\"2026-08-19T00:00:00Z\"]\n } \n ],\n \"groupBy\": [\n \"companyId\",\n \"flowId\",\n \"nodeId\",\n \"bucketTimestamp\"\n ]\n}");
Request request = new Request.Builder()
.url("{{apiPath}}/v1/environments/{{envID}}/metrics/davinci")
.method("POST", body)
.addHeader("Content-Type", "application/json")
.addHeader("Authorization", "Bearer {{accessToken}}")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{apiPath}}/v1/environments/{{envID}}/metrics/davinci",
"method": "POST",
"timeout": 0,
"headers": {
"Content-Type": "application/json",
"Authorization": "Bearer {{accessToken}}"
},
"data": JSON.stringify({
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": [
"{{davinciFlowID}}"
]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": [
"2026-08-19T00:00:00Z"
]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
}),
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{apiPath}}/v1/environments/{{envID}}/metrics/davinci',
'headers': {
'Content-Type': 'application/json',
'Authorization': 'Bearer {{accessToken}}'
},
body: JSON.stringify({
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": [
"{{davinciFlowID}}"
]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": [
"2026-08-19T00:00:00Z"
]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
})
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
import json
url = "{{apiPath}}/v1/environments/{{envID}}/metrics/davinci"
payload = json.dumps({
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": [
"{{davinciFlowID}}"
]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": [
"2026-08-19T00:00:00Z"
]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
})
headers = {
'Content-Type': 'application/json',
'Authorization': 'Bearer {{accessToken}}'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/metrics/davinci');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'Content-Type' => 'application/json',
'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n "entityType": "DAVINCI_FLOW_NODE_METRICS",\n "selectFields": [\n "companyId",\n "flowId",\n "nodeId",\n "bucketTimestamp"\n ],\n "aggregations": [\n {\n "field": "invocationCount",\n "aggregatorType": "SUM",\n "alias": "invocationCount"\n },\n {\n "field": "completionCount",\n "aggregatorType": "SUM",\n "alias": "completionCount"\n },\n {\n "field": "errorCount",\n "aggregatorType": "SUM",\n "alias": "errorCount"\n },\n {\n "field": "timeoutCount",\n "aggregatorType": "SUM",\n "alias": "timeoutCount"\n },\n {\n "field": "executionTime",\n "aggregatorType": "AVG",\n "alias": "executionTime"\n }\n ],\n "queryFilters": [\n {\n "field": "flowId",\n "operator": "EQUALS",\n "values": ["{{davinciFlowID}}"]\n },\n {\n "field": "bucketTimestamp",\n "operator": "LESS_THAN",\n "values": ["2026-08-19T00:00:00Z"]\n } \n ],\n "groupBy": [\n "companyId",\n "flowId",\n "nodeId",\n "bucketTimestamp"\n ]\n}');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"
url = URI("{{apiPath}}/v1/environments/{{envID}}/metrics/davinci")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"selectFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": [
"{{davinciFlowID}}"
]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": [
"2026-08-19T00:00:00Z"
]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
})
response = http.request(request)
puts response.read_body
let parameters = "{\n \"entityType\": \"DAVINCI_FLOW_NODE_METRICS\",\n \"selectFields\": [\n \"companyId\",\n \"flowId\",\n \"nodeId\",\n \"bucketTimestamp\"\n ],\n \"aggregations\": [\n {\n \"field\": \"invocationCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"invocationCount\"\n },\n {\n \"field\": \"completionCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"completionCount\"\n },\n {\n \"field\": \"errorCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"errorCount\"\n },\n {\n \"field\": \"timeoutCount\",\n \"aggregatorType\": \"SUM\",\n \"alias\": \"timeoutCount\"\n },\n {\n \"field\": \"executionTime\",\n \"aggregatorType\": \"AVG\",\n \"alias\": \"executionTime\"\n }\n ],\n \"queryFilters\": [\n {\n \"field\": \"flowId\",\n \"operator\": \"EQUALS\",\n \"values\": [\"{{davinciFlowID}}\"]\n },\n {\n \"field\": \"bucketTimestamp\",\n \"operator\": \"LESS_THAN\",\n \"values\": [\"2026-08-19T00:00:00Z\"]\n } \n ],\n \"groupBy\": [\n \"companyId\",\n \"flowId\",\n \"nodeId\",\n \"bucketTimestamp\"\n ]\n}"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/metrics/davinci")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
200 OK
{
"_links": {
"self": {
"href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/metrics/davinci"
}
},
"count": 0,
"size": 0,
"pagination": {
"limit": 1000,
"hasMoreResults": false
},
"originalRequest": {
"entityType": "DAVINCI_FLOW_NODE_METRICS",
"environmentId": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6",
"selectedFields": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
],
"aggregations": [
{
"field": "invocationCount",
"aggregatorType": "SUM",
"alias": "invocationCount"
},
{
"field": "completionCount",
"aggregatorType": "SUM",
"alias": "completionCount"
},
{
"field": "errorCount",
"aggregatorType": "SUM",
"alias": "errorCount"
},
{
"field": "timeoutCount",
"aggregatorType": "SUM",
"alias": "timeoutCount"
},
{
"field": "executionTime",
"aggregatorType": "AVG",
"alias": "executionTime"
}
],
"queryFilters": [
{
"field": "flowId",
"operator": "EQUALS",
"values": [
"6f37adaa00c6bad9d7b4ec966ea0903b"
]
},
{
"field": "bucketTimestamp",
"operator": "LESS_THAN",
"values": [
"2026-08-19T00:00:00Z"
]
}
],
"groupBy": [
"companyId",
"flowId",
"nodeId",
"bucketTimestamp"
]
},
"createdAt": "2026-08-05T16:09:10.963792965Z"
}